C------------------SUBPROGRAMS-----------------------------------------------------------------

	function RIJ(x1,y1,z1,x2,y2,z2)
 
	real*8 rij,x1,y1,z1,x2,y2,z2

	real*8 dx,dy,dz

	RIJ = 0.d0
	Dx = x2 - x1
	Dx = dx - dnint(dx)
	RIJ = RIJ + dx*dx
	Dy = y2 - y1
	Dy = dy - dnint(dy)
	RIJ = RIJ + dy*dy
	Dz = z2 - z1
	Dz = dz - dnint(dz)
	RIJ = RIJ + dz*dz
	RIJ = dsqrt(RIJ)
	Return
	End

c----------------------------------------------------------------------------------------------

	function RIJ2(x1,y1,z1,x2,y2,z2)
 
	real*8 rij2,x1,y1,z1,x2,y2,z2

	real*8 dx,dy,dz

	RIJ2 = 0.d0
	Dx = x2 - x1
	Dx = dx - dnint(dx)
	RIJ2 = RIJ2 + dx*dx
	Dy = y2 - y1
	Dy = dy - dnint(dy)
	RIJ2 = RIJ2 + dy*dy
	Dz = z2 - z1
	Dz = dz - dnint(dz)
	RIJ2 = RIJ2 + dz*dz
	Return
	End

c----------------------------------------------------------------------------------------------

	function VLJ(r2,s2,e)

	real*8	vlj, r2, s2, e, ovlp2
	common /overl/ ovlp2

	R1 = s2/r2
	if(R1.LT.ovlp2) R1 = ovlp2
	R1 = r1**3
	VLJ = 4.d0*e*r1*(r1-1.d0)
c	if(VLJ.GT.100.d0) VLJ = 100.d0

	Return 
	end

c----------------------------------------------------------------------------------------------

	SUBROUTINE ranor(bx,by,bz)

c	as described in Frenkel*s book

	integer iseed
	real*8 bx,by,bz

	real*8 ransq, ran1, ran2, ranh

	common /seed/ iseed

	ransq=2.d0
	do while(ransq>=1.d0)
		ran1 = 1.d0 - 2.d0 * ran(iseed)
		ran2 = 1.d0 - 2.d0 * ran(iseed)
		ransq = ran1*ran1 + ran2*ran2
	End do

	ranh = 2.d0 * dsqrt(1.d0 - ransq)

	bx = ran1*ranh
	by = ran2*ranh
	bz = 1.d0 - 2.d0*ransq

	return
	end

c----------------------------------------------------------------------------------------------

	SUBROUTINE select(nphi,w,sumw,n)

c	as described in Frenkel*s book

	integer n, nphi, iseed
	real*8 w(nphi),sumw

	real*8 ws, cumw

	common /seed/ iseed

	ws = sumw*ran(iseed)
	cumw = w(1)
	
	n = 1
	do while (cumw < ws)
		n = n + 1
		cumw = cumw + w(n)
	end do

	return
	end

c----------------------------------------------------------------------------------------------

	SUBROUTINE Xprod(u1,u2,u3,nc,maxc,flaglist)

	integer nc,maxc,flaglist(Maxc)
	real*8 u1(3,maxc),u2(3,maxc),u3(3,maxc)

	integer i
	real*8 ulen

	Do i=1,nc
		if(flaglist(i).ne.0) then
			u3(1,i) = u1(2,i)*u2(3,i)-u1(3,i)*u2(2,i)
			u3(2,i) = u1(3,i)*u2(1,i)-u1(1,i)*u2(3,i)
			u3(3,i) = u1(1,i)*u2(2,i)-u1(2,i)*u2(1,i)

			ulen = u3(1,i)*u3(1,i)+u3(2,i)*u3(2,i)+u3(3,i)*u3(3,i)
			if(.not.(ulen.ge.0.d0)) then
				write(*,*) 'error in Xprod'
				write(*,*) i,ulen
				write(*,*) u3(:,i)
				pause
			end if
			ulen = dsqrt(ulen)
			u3(1,i) = u3(1,i)/ulen
			u3(2,i) = u3(2,i)/ulen
			u3(3,i) = u3(3,i)/ulen
		endif
	End Do

	RETURN
	END 

c----------------------------------------------------------------------------------------------

	SUBROUTINE Xp(u1,u2,u3)

	real*8 u1(3),u2(3),u3(3)

	real*8 ulen

	u3(1) = u1(2)*u2(3)-u1(3)*u2(2)
	u3(2) = u1(3)*u2(1)-u1(1)*u2(3)
	u3(3) = u1(1)*u2(2)-u1(2)*u2(1)

	ulen = u3(1)*u3(1)+u3(2)*u3(2)+u3(3)*u3(3)
	if(.not.(ulen.ge.0.d0)) then
		write(*,*) 'error in Xp'
		write(*,*) ulen
		pause
	end if
	ulen = dsqrt(ulen)
	u3(1) = u3(1)/ulen
	u3(2) = u3(2)/ulen
	u3(3) = u3(3)/ulen

	RETURN
	END 

