	program mc_1

	implicit none

	integer maxch,maxnat,maxtest,maxatsys
	Parameter(Maxch = 120, MaxAtSys=1100)
	Parameter(MaxNat = MaxAtSys, Maxtest=111)

	Real*8 conv, Emax
	Parameter(conv = 1.43964d-4, Emax=1.d+5)
c	Parameter(conv = 1.45675d-5, Emax=1.d+5)

	Real*8 XYZ(3,Maxch,MaxNat),bnd(maxch,maxnat) 
	Real*8 th(maxch,maxnat),fnew(0:maxch,maxnat),f(0:maxch,maxnat)
	Real*8 sig1,sig10,sig2,sig12, eps1
	Real*8 Eold,Enew,Ebond,Elj,DE1,DE2,DE,E,DEV
	Real*8 BL,BLnew,R0,blen,blen0,dens,Navog,theta,beta,ovlp2,kinv,pi
	Real*8 MW,fw1,fw2,fw3,temp,temperature,ovlp,Vtor,const,dist
	Real*8 theta0,theta1,theta2,ulen
	Real*8 rcut,rc,rcutsq,rr, kl,kl0, kth,disp,rnd
	Real*8 nc(3),vb1(3),vb2(3),bprod,b1,b2,b11,b22
	Real*8 vbm1(3),vb0(3),vb3(3),vb4(3)
	Real*8 xo,yo,zo,xn,yn,zn,dx,dy,dz,w,dx1,dx2
	Real*8 x, y, z, rij, rij2,Ebest, ksi,ksi0
	Real*8 u1(3),u2(3),u3(3),u4(3),u5(3),fsum(4),tmp
	Real*8 oc(3),r2new,r2old,VLJ,rchoice
	Real*8 bb,ll,l1,l2,ll2,ll6,ll12,E0,Elj1,Elj2
	Real*8 V0,Vnew,Vstep,DV,lnvn,Pres,Clrc,DElrc
	Real*4 tim,verysmall
	parameter(verysmall=1.e-8)
	Integer nch,i,j,k,l,m,n,Natmc(Maxch),Natsu(Maxch),nat,itest,nold
	Integer kount,iseed,ich,iat,nphi,ntest,ptrat,ptrch,natmax
	Integer flaglist(maxch),nfreq,nstart,ik,jl
	Integer stepcount,atomcheck,boxcount,boxcheck,ratio
	Integer	nspec(0:maxch), McNat(maxch), SuNat(maxch)
	Integer IERR(20)
	logical flag,test, volfluc,exst
	character*12 filin, filout

	external vlj, rij, rij2

	common /seed/ iseed
	common /overl/ ovlp2

	Data Navog/6.0221415D+23/
	Data kinv /503.4d0/

c---------------------------------------------------------------------

c----- Read in parameters

	IERR(:) = 0
	exst = .FALSE.

59	print*, 'input file name?'
	read(*,*) filin
	inquire(file=filout, EXIST = exst)
	if(exst) then
		write(*,73) filin 
		write(*,75)	
		goto 59
	endif
60	print*, 'output file name?'
	read(*,*) filout
	inquire(file=filout, EXIST = exst)
	if(exst) then
		write(*,74) filout
		write(*,75)	
		goto 60
	endif

	open(unit=9,file='mol.in')

	n = 0
	Read(9,*) nch, nspec(0)
	Do i=1,nspec(0)
		Read(9,*) nspec(i), McNat(i), SuNat(i)
		Do j=1,nspec(i)
			n=n+1
			Natmc(n)=McNat(i)
			Natsu(n)=SuNat(i)
		End Do
	Enddo
	n = 0

	Read(9,*) fw1,fw2,fw3
	Read(9,*) temperature
	Read(9,*) dens
	Read(9,*) blen0
	Read(9,*) theta
	Read(9,*) ovlp
	Read(9,*) Vtor
	Read(9,*) nphi
	Read(9,*) iseed
	Read(9,*) sig10
	Read(9,*) eps1
	Read(9,*) Ntest

	Read(9,*) Nstart
	Read(9,*) Nfreq
	Read(9,*) kl0
	Read(9,*) kth
	Read(9,*) rcut
	Read(9,*) ksi0
	Read(9,*) volfluc
	Read(9,*) Vstep
	Read(9,*) Pres
	Read(9,*) atomcheck
	Read(9,*) boxcheck

	close(9)
c
c----- Read in coordinates
c
c	open(unit=10, file='Mol.out')
c	open(unit=10, file='Chassapis.build') 
	open(unit=10, file=filin)

	n = 0
	Read(10,*) nch, nspec(0)
	Do i=1,nspec(0)
		Read(10,*) nspec(i), McNat(i), SuNat(i)
		Do j=1,nspec(i)
			n=n+1
			Natmc(n)=McNat(i)
			Natsu(n)=SuNat(i)
		End Do
	Enddo
	n = 0

	read(10,*) BL
	read(10,*) 
	read(10,*) 
	Do ich=1,nch
		Do iat=1,Natmc(ich)
			read(10,*) k,(xyz(i,ich,iat),i=1,3),f(ich,iat)
		End Do
	End Do
	Read(10,*) 
	Read(10,*) iseed
	Read(10,*) dens
	close(10)

c----- Initialize

	Blen = blen0/BL
	Sig1 = sig10/BL
	Sig12 = Sig1**2
	ksi = ksi0/BL
	nat = 0
	Do i=1, nch
	  nat = nat+natmc(i)
	End Do
	kl=0.5d0*kl0*BL*BL
	kth=0.5d0*kth
	Vtor=0.5d0*Vtor
	beta=kinv/temperature
	Pi = 4.d0*datan(1.d0)
	theta = theta*Pi/180.d0
	Pres = conv*Pres

C	Define Overlap and Rcut

	R0 = ovlp*sig1
	R0 = R0**2
	ovlp2 = ovlp**2
	Rc = rcut*sig1
	Rcutsq = Rc**2

c	Initialize counters

	stepcount=0
	boxcount=0

C	Define long range correction term (will be divided by volume) 

	Clrc = -(8.0d0/3.0d0)*Pi*Nat**2*eps1*(sig10/rcut)**3

c---- Go!!!

	Do ich=1,nch
	  Do iat=1,natmc(ich)-2
	    bnd(ich,iat)=blen
		th(ich,iat)=theta
	  End do
	  if(natmc(ich).gt.1) bnd(ich,natmc(ich)-1)=blen
	End Do
	MW = 0.d0
	Do i=1,nch
		MW = MW + (Natmc(i) - 2)*fw1 + 2*fw2
	Enddo

c	Start the BIG LOOP

c	open(unit=14, file='traject')

	E = 0.d0
	Ebest = Emax
c	Ebest = 0.d0
	kount=0
	Do itest = 1,Ntest

c	Select type of change

	  rchoice = 1	
	  if(volfluc) then
	    rnd = 1+ran(iseed)*(nat+1)
	    if (rnd.gt.nat) rchoice = 2
	    if (rchoice.eq.2) goto 500
	  endif

c	Attempt Particle Move	
c	-------------------------------
c	Select atom at random

2000	  rnd = ran(iseed)
	  ptrat = int(nat*rnd)+1

	  nold = 0
	  n = 0
	  Do i=1, nch
	    nold = n
	    n = n+natmc(i)
	    if(ptrat.le.n) goto 10
	  End Do
10	  ptrch = i
        ptrat = ptrat-nold
	  natmax = natmc(ptrch)

c	Select displacement according to exp(-disp/ksi) = random

	  test = .TRUE.
	  Do while(test)
	    rnd = amax1(ran(iseed),verysmall)
	    rnd = -ksi*dlog(rnd)
	    CALL ranor(dx,dy,dz)
	    xo=xyz(1,ptrch,ptrat)
	    yo=xyz(2,ptrch,ptrat)
	    zo=xyz(3,ptrch,ptrat)
	    xn=xo+rnd*dx
	    yn=yo+rnd*dy
	    zn=zo+rnd*dz
	    nc(1)=xn-dnint(xn)
	    nc(2)=yn-dnint(yn)
	    nc(3)=zn-dnint(zn)
	    kount = 0
	    Do i=1,ptrch-1
	      Do j=1,natmc(i)
		    r2new = rij2(nc(1),nc(2),nc(3),
     &	    xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		    if(r2new.lt.R0) kount = kount+1
	      End Do
	    End Do

	    Do j=1,ptrat-3
		  r2new = rij2(nc(1),nc(2),nc(3),
     &	  xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		  if(r2new.lt.R0) kount = kount+1
	    End Do
	    Do j=ptrat+3,natmax
		  r2new = rij2(nc(1),nc(2),nc(3),
     &	  xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		  if(r2new.lt.R0) kount = kount+1
	    End Do

	    Do i=ptrch+1,nch
	      Do j=1,natmc(i)
		    r2new = rij2(nc(1),nc(2),nc(3),
     &  	    xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		    if(r2new.lt.R0) kount = kount+1
	      End Do
	    End Do
	    if(kount.eq.0) test = .FALSE.
	  End Do

c	Compute new energy.
c     I. Bond stretching

	  if(natmc(ptrch).eq.1) goto 999

	  Eold = 0.d0
	  Enew = 0.d0
	  if(ptrat.ge.2) then 
		b1 = rij(nc(1),nc(2),nc(3),xyz(1,ptrch,ptrat-1),
     &	  xyz(2,ptrch,ptrat-1),xyz(3,ptrch,ptrat-1))
	    Eold = Eold + (bnd(ptrch,ptrat-1)-blen)**2
	    Enew = Enew + (b1-blen)**2
	  end if
	  if(ptrat.le.natmax-1) then
		b2 = rij(nc(1),nc(2),nc(3),xyz(1,ptrch,ptrat+1),
     &	  xyz(2,ptrch,ptrat+1),xyz(3,ptrch,ptrat+1))
	    Eold = Eold + (bnd(ptrch,ptrat)-blen)**2
	    Enew = Enew + (b2-blen)**2
	  end if

	  DE = kl*(Enew-Eold)

c     II. Bond Angles

	  if(natmc(ptrch).le.2) goto 999

	  Eold = 0.d0
	  Enew = 0.d0
	  if ((ptrat.ge.2).and.(ptrat.le.natmax-1)) then
		bprod = 0.d0
		do k=1,3
			dx1 = nc(k) - xyz(k,ptrch,ptrat-1)
			dx2 = xyz(k,ptrch,ptrat+1) - nc(k)
			dx1 = dx1-dnint(dx1)	!	PBC
			dx2 = dx2-dnint(dx2)	!	PBC
			bprod = bprod - dx1*dx2	!	obtuse angles, hence minus sign
			vb1(k) = dx1
			vb2(k) = dx2
		enddo
		temp = bprod/(b1*b2)
		if(dabs(temp).gt.1.d0) then
		  IERR(1) = IERR(1)+1
		  goto 2000
		end if
		theta0 = dacos(temp)
	    Eold = Eold + (th(ptrch,ptrat-1)-theta)**2 ! #
	    Enew = Enew + (theta0-theta)**2
	  endif
	  if ((ptrat.ge.3).and.(ptrat.le.natmax-1)) then
		bprod = 0.d0
		do k=1,3
			dx2 = xyz(k,ptrch,ptrat-1) - xyz(k,ptrch,ptrat-2)
			dx2 = dx2-dnint(dx2)		!	PBC
			bprod = bprod - vb1(k)*dx2	!	obtuse angles, hence minus sign
		enddo
		b11 = b1*bnd(ptrch,ptrat-2)
		temp = bprod/b11
		if(dabs(temp).gt.1.d0) then
			IERR(2) = IERR(2)+1
		    goto 2000
		end if
		theta1 = dacos(temp)
	    Eold = Eold + (th(ptrch,ptrat-2)-theta)**2 ! #
	    Enew = Enew + (theta1-theta)**2
	  endif
	  if ((ptrat.ge.2).and.(ptrat.le.natmax-2)) then
		bprod = 0.d0
		do k=1,3
			dx1 = xyz(k,ptrch,ptrat+2) - xyz(k,ptrch,ptrat+1)
			dx1 = dx1-dnint(dx1)		!	PBC
			bprod = bprod - vb2(k)*dx1	!	obtuse angles, hence minus sign
		enddo
		b22 = b2*bnd(ptrch,ptrat+1)
		temp = bprod/b22
		if(dabs(temp).gt.1.d0) then
			IERR(3) = IERR(3)+1
			goto 2000
		end if
		theta2 = dacos(temp)
	    Eold = Eold + (th(ptrch,ptrat)-theta)**2 ! #
	    Enew = Enew + (theta2-theta)**2
	  endif

c	Bond Angles: special cases
	
	  if(ptrat.eq.1) then
		bprod = 0.d0
		do k=1,3
			dx1 = xyz(k,ptrch,ptrat+1) - nc(k)
			dx2 = xyz(k,ptrch,ptrat+2) - xyz(k,ptrch,ptrat+1)
			dx1 = dx1-dnint(dx1)	!	PBC
			dx2 = dx2-dnint(dx2)	!	PBC
			bprod = bprod - dx1*dx2	!	obtuse angles, hence minus sign
		enddo
		b22 = b2*bnd(ptrch,ptrat+1)
		temp = bprod/b22
		if(dabs(temp).gt.1.d0) then
			IERR(4) = IERR(4)+1
		    goto 2000
		end if
		theta0 = dacos(temp)
	    Eold = Eold + (th(ptrch,ptrat)-theta)**2
	    Enew = Enew + (theta0-theta)**2
	  endif

	  if(ptrat.eq.natmax) then
		bprod = 0.d0
		do k=1,3
			dx1 = nc(k) - xyz(k,ptrch,ptrat-1)
			dx2 = xyz(k,ptrch,ptrat-1) - xyz(k,ptrch,ptrat-2)
			dx1 = dx1-dnint(dx1)	!	PBC
			dx2 = dx2-dnint(dx2)	!	PBC
			bprod = bprod - dx1*dx2	!	obtuse angles, hence minus sign
		enddo
		b11 = b1*bnd(ptrch,ptrat-2)
		temp = bprod/b11
		if(dabs(temp).gt.1.d0) then
			IERR(5) = IERR(5)+1
		    goto 2000
		end if
		theta0 = dacos(temp)
	    Eold = Eold + (th(ptrch,ptrat-2)-theta)**2
	    Enew = Enew + (theta0-theta)**2
	  endif

	  DE = DE + kth*(Enew-Eold)

c	III. Dihedral angles

	  if(natmc(ptrch).le.3) goto 999

	  if ((ptrat.gt.3).and.(ptrat.le.natmax-3)) then

	    Eold = 0.d0
	    Enew = 0.d0
	    Do k = ptrat-1,ptrat+2
		  Eold = Eold + 1.d0 + dcos(3.d0*f(ptrch,k))
		End Do

		do k=1,3
			dx1 = xyz(k,ptrch,ptrat-2) - xyz(k,ptrch,ptrat-3)
			dx1 = dx1-dnint(dx1)	!	PBC
			vbm1(k) = dx1
			dx1 = xyz(k,ptrch,ptrat-1) - xyz(k,ptrch,ptrat-2)
			dx1 = dx1-dnint(dx1)	!	PBC
			vb0(k) = dx1
			dx1 = xyz(k,ptrch,ptrat+2) - xyz(k,ptrch,ptrat+1)
			dx1 = dx1-dnint(dx1)	!	PBC
			vb3(k) = dx1
			dx1 = xyz(k,ptrch,ptrat+3) - xyz(k,ptrch,ptrat+2)
			dx1 = dx1-dnint(dx1)	!	PBC
			vb4(k) = dx1
		enddo
		
		CALL Xp(vbm1,vb0,u1)		
		CALL Xp(vb0, vb1,u2)		
		CALL Xp(vb1, vb2,u3)		
		CALL Xp(vb2, vb3,u4)		
		CALL Xp(vb3, vb4,u5)		

		Do k=1,4		
		  fsum(k) =0.d0		
		End Do
		Do k=1,3
	      fsum(1) = fsum(1)+u1(k)*u2(k)
	      fsum(2) = fsum(2)+u2(k)*u3(k)
	      fsum(3) = fsum(3)+u3(k)*u4(k)
	      fsum(4) = fsum(4)+u4(k)*u5(k)
		End Do

		Do k=ptrat-1,ptrat+2
			temp = fsum(k-ptrat+2)
			if(dabs(temp).gt.1.d0) then
				IERR(6) = IERR(6)+1
				goto 2000
			end if
			fnew(ptrch,k) = dacos(temp)
		End Do

		tmp = 0.d0
	    Do k=1,3
	      tmp = tmp - u1(k)*vb1(k)
		End Do
		fnew(ptrch,ptrat-1) = dsign(fnew(ptrch,ptrat-1),tmp)
		tmp = 0.d0
	    Do k=1,3
	      tmp = tmp - u2(k)*vb2(k)
		End Do
		fnew(ptrch,ptrat) = dsign(fnew(ptrch,ptrat),tmp)
		tmp = 0.d0
	    Do k=1,3
	      tmp = tmp - u3(k)*vb3(k)
		End Do
		fnew(ptrch,ptrat+1) = dsign(fnew(ptrch,ptrat+1),tmp)
		tmp = 0.d0
	    Do k=1,3
	      tmp = tmp - u4(k)*vb4(k)
		End Do
		fnew(ptrch,ptrat+2) = dsign(fnew(ptrch,ptrat+2),tmp)

	    Do k = ptrat-1,ptrat+2
		  Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,k))
		End Do

	  End if

c	Dihedral angles special cases

c	a. beginning of chain
	
	  if(natmax.lt.4) goto 999
	  if(ptrat.lt.4) then
	
	    Eold = 0.d0
	    Enew = 0.d0
		l = min0(2+ptrat,natmax-1)
	    Do k = 3,2+ptrat
		  Eold = Eold + 1.d0 + dcos(3.d0*f(ptrch,k))
		End Do

		do k=1,3
			if(ptrat+1.le.natmax) then
			  dx1 = xyz(k,ptrch,ptrat+1) - xyz(k,ptrch,ptrat)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vb2(k) = dx1
			endif
			if(ptrat+2.le.natmax) then
			  dx1 = xyz(k,ptrch,ptrat+2) - xyz(k,ptrch,ptrat+1)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vb3(k) = dx1
			endif
			if(ptrat+3.le.natmax) then
			  dx1 = xyz(k,ptrch,ptrat+3) - xyz(k,ptrch,ptrat+2)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vb4(k) = dx1
			endif
		enddo
		if(ptrat+2.le.natmax) CALL Xp(vb2,vb3,u4)		
		
		if(ptrat+3.le.natmax) then
		
		  CALL Xp(vb3,vb4,u5)		

		  fsum(4) =0.d0		
		  Do k=1,3
	        fsum(4) = fsum(4)+u4(k)*u5(k)
		  End Do
		  temp = fsum(4)
		  if(dabs(temp).gt.1.d0) then
			IERR(7) = IERR(7)+1
			goto 2000
		  end if
		  fnew(ptrch,ptrat+2) = dacos(temp)
		  tmp = 0.d0
	      Do k=1,3
	        tmp = tmp - u4(k)*vb4(k)
		  End Do
		  fnew(ptrch,ptrat+2) = dsign(fnew(ptrch,ptrat+2),tmp)

		  Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat+2))

		endif

		if(ptrat.ge.2) then
		  if(ptrat+1.le.natmax) CALL Xp(vb1, vb2,u3)		
		  if(ptrat+2.le.natmax) then
		  
			CALL Xp(vb2, vb3,u4)		
			fsum(3) =0.d0		
			Do k=1,3
				fsum(3) = fsum(3)+u3(k)*u4(k)
			End Do
		    temp = fsum(3)
		    if(dabs(temp).gt.1.d0) then
			  IERR(8) = IERR(8)+1
			  goto 2000
		    end if
			fnew(ptrch,ptrat+1) = dacos(temp)
			tmp = 0.d0
			Do k=1,3
				tmp = tmp - u3(k)*vb3(k)
			End Do
			fnew(ptrch,ptrat+1) = dsign(fnew(ptrch,ptrat+1),tmp)

			Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat+1))
		  endif
		endif	  

		if(ptrat.eq.3) then
		  do k=1,3
			  dx1 = xyz(k,ptrch,ptrat-1) - xyz(k,ptrch,ptrat-2)
			  dx1 = dx1-dnint(dx1)	!	PBC
		  	  vb0(k) = dx1
		  enddo
		  CALL Xp(vb0, vb1,u2)		
		  CALL Xp(vb1, vb2,u3)		
		  fsum(2) =0.d0		
		  Do k=1,3
	        fsum(2) = fsum(2)+u2(k)*u3(k)
		  End Do
		  temp = fsum(2)
		  if(dabs(temp).gt.1.d0) then
			IERR(9) = IERR(9)+1
			goto 2000
		  end if
		  fnew(ptrch,ptrat) = dacos(temp)
		  tmp = 0.d0
	      Do k=1,3
	        tmp = tmp - u2(k)*vb2(k)
		  End Do
		  fnew(ptrch,ptrat) = dsign(fnew(ptrch,ptrat),tmp)

		  Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat))
		endif	  

	  end if

c	b. End of chain

	  if(ptrat.ge.natmax-2) then

	    Eold = 0.d0
	    Enew = 0.d0
		l = max0(3,ptrat-1)
	    Do k = l,natmax-1
		  Eold = Eold + 1.d0 + dcos(3.d0*f(ptrch,k))
		End Do

		do k=1,3
			if(ptrat.gt.3) then
			  dx1 = xyz(k,ptrch,ptrat-2) - xyz(k,ptrch,ptrat-3)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vbm1(k) = dx1
			endif
			if(ptrat.gt.2) then
			  dx1 = xyz(k,ptrch,ptrat-1) - xyz(k,ptrch,ptrat-2)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vb0(k) = dx1
			endif
			if(ptrat.gt.1) then
			  dx1 = xyz(k,ptrch,ptrat) - xyz(k,ptrch,ptrat-1)
			  dx1 = dx1-dnint(dx1)	!	PBC
			  vb1(k) = dx1
			endif
		enddo
		if(ptrat.gt.2) CALL Xp(vb0, vb1,u2)
		if(ptrat.gt.3) then 
		  
		  CALL Xp(vbm1,vb0,u1)	
		 
		  fsum(1) =0.d0		
		  Do k=1,3
	        fsum(1) = fsum(1)+u1(k)*u2(k)
		  End Do
		  temp = fsum(1)
		  if(dabs(temp).gt.1.d0) then
			IERR(10) = IERR(10)+1
			goto 2000
		  end if
		  fnew(ptrch,ptrat-1) = dacos(temp)
		  tmp = 0.d0
	      Do k=1,3
	        tmp = tmp - u1(k)*vb1(k)
		  End Do
		  fnew(ptrch,ptrat-1) = dsign(fnew(ptrch,ptrat-1),tmp)

		  Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat-1))

		endif

		if(ptrat.le.natmax-1) then
		  do k=1,3
			dx1 = xyz(k,ptrch,ptrat+1) - xyz(k,ptrch,ptrat)
			dx1 = dx1-dnint(dx1)	!	PBC
			vb2(k) = dx1
		  enddo
		  CALL Xp(vb1, vb2,u3)		
		  if(ptrat.gt.2) then
		  
		    CALL Xp(vb0, vb1,u2)		
		    fsum(2) =0.d0		
		    Do k=1,3
	          fsum(2) = fsum(2)+u2(k)*u3(k)
		    End Do
		    temp = fsum(2)
		    if(dabs(temp).gt.1.d0) then
			  IERR(11) = IERR(11)+1
			  goto 2000
		    end if
		    fnew(ptrch,ptrat) = dacos(temp)
		    tmp = 0.d0
	        Do k=1,3
	          tmp = tmp - u2(k)*vb2(k)
		    End Do
		    fnew(ptrch,ptrat) = dsign(fnew(ptrch,ptrat),tmp)

		    Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat))
		  endif
		endif	  

		if(ptrat.eq.natmax-2) then
		  do k=1,3
			  dx1 = xyz(k,ptrch,ptrat+2) - xyz(k,ptrch,ptrat+1)
			  dx1 = dx1-dnint(dx1)	!	PBC
		  	  vb3(k) = dx1
		  enddo
		  CALL Xp(vb1, vb2,u3)		
		  CALL Xp(vb2, vb3,u2)		
		  fsum(3) =0.d0		
		  Do k=1,3
	        fsum(3) = fsum(3)+u2(k)*u3(k)
		  End Do
		  temp = fsum(3)
		  if(dabs(temp).gt.1.d0) then
			IERR(12) = IERR(12)+1
			goto 2000
		  end if
		  fnew(ptrch,ptrat+1) = dacos(temp)
		  tmp = 0.d0
	      Do k=1,3
	        tmp = tmp - u3(k)*vb3(k)
		  End Do
		  fnew(ptrch,ptrat+1) = dsign(fnew(ptrch,ptrat+1),tmp)

		  Enew = Enew + 1.d0 + dcos(3.d0*fnew(ptrch,ptrat+1))
		endif	  

	  end if

	  DE = DE + Vtor*(Enew-Eold)

c	IV. Non-bonded pairs energy

999	  oc(1)=xyz(1,ptrch,ptrat)
	  oc(2)=xyz(2,ptrch,ptrat)
	  oc(3)=xyz(3,ptrch,ptrat)
	  Eold = 0.d0
	  Enew = 0.d0
	  Do i=1,ptrch-1
	    Do j=1,natmc(i)
		  r2old = rij2(oc(1),oc(2),oc(3),
     &	  xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		  if(r2old.le.rcutsq) Eold = Eold + VLJ(r2old,sig12,eps1)
		  r2new = rij2(nc(1),nc(2),nc(3),
     &	  xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		  if(r2new.le.rcutsq) Enew = Enew + VLJ(r2new,sig12,eps1)
	    End Do
	  End Do

c	  Do j=1,ptrat-3
	  Do j=1,ptrat-4
		r2old = rij2(oc(1),oc(2),oc(3),
     &	xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		if(r2old.le.rcutsq) Eold = Eold + VLJ(r2old,sig12,eps1)
		r2new = rij2(nc(1),nc(2),nc(3),
     &	xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		if(r2new.le.rcutsq) Enew = Enew + VLJ(r2new,sig12,eps1)
	  End Do
c	  Do j=ptrat+3,natmax
	  Do j=ptrat+4,natmax
		r2old = rij2(oc(1),oc(2),oc(3),
     &	xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		if(r2old.le.rcutsq) Eold = Eold + VLJ(r2old,sig12,eps1)
		r2new = rij2(nc(1),nc(2),nc(3),
     &	xyz(1,ptrch,j),xyz(2,ptrch,j),xyz(3,ptrch,j))
		if(r2new.le.rcutsq) Enew = Enew + VLJ(r2new,sig12,eps1)
	  End Do

	  Do i=ptrch+1,nch
	    Do j=1,natmc(i)
		  r2old = rij2(oc(1),oc(2),oc(3),
     &	  xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		  if(r2old.le.rcutsq) Eold = Eold + VLJ(r2old,sig12,eps1)
		  r2new = rij2(nc(1),nc(2),nc(3),
     &	  xyz(1,i,j),xyz(2,i,j),xyz(3,i,j))
		  if(r2new.le.rcutsq) Enew = Enew + VLJ(r2new,sig12,eps1)
	    End Do
	  End Do

	  DE = DE + Enew-Eold

500	  if (rchoice.eq.1) goto 1000

c	  Attempt Volume Change		  
c	--------------------------------------

		V0 =BL**3
		DV = (ran(iseed)-0.5d0)*Vstep
		lnvn = dlog(V0) + DV
		Vnew = DEXP(lnvn)
		BLnew = Vnew**0.333333333333333d0

c		Eold:Run through all bonds and atom pairs
		
		Ebond = 0.d0
		do i=1,nch
			do j=1,natmc(i)-1
				Ebond = Ebond + (bnd(i,j)-blen)**2
			enddo
		enddo	
		Eold = kl*Ebond
C		Eold = 0.d0

		Elj1 = 0.d0
		Elj2 = 0.d0
		do i=1,nch
			do j=1,natmc(i)
				do k=i,nch
					do l=1,natmc(k)
						ik=iabs(i-k)
						jl=iabs(j-l)
c						if (ik.eq.0.and.l.lt.j+3) goto 900 ! jl.lt.3) goto 900
						if (ik.eq.0.and.l.lt.j+4) goto 900 ! jl.lt.3) goto 900
						rr = Rij2(xyz(1,i,j),xyz(2,i,j),xyz(3,i,j),
     & 					xyz(1,k,l),xyz(2,k,l),xyz(3,k,l))
						if(rr.lt.rcutsq) then
						  E0 = sig12/rr
						  E0 = E0*E0*E0
c						  if (E0.gt.10.d0) E0 = 10.d0
						  Elj1 = Elj1 + E0
						  Elj2 = Elj2 + E0*E0
						endif
900						continue
					enddo ! ch#2 atoms
				enddo ! ch#2
			enddo ! ch#1 atoms
		enddo ! ch#1 

c		Enew: Run through all new bonds and atom pairs

		bb = blen0/BLnew
		ll = BL/BLnew
		ll2= ll*ll
		ll6= ll2**3
		ll12 = ll6*ll6
		l1 = ll6 - 1.d0
		l2 = ll12 - 1.d0

		Ebond = 0.d0
		do i=1,nch
			do j=1,natmc(i)-1
				Ebond = Ebond + (bnd(i,j)-bb)**2
			enddo
		enddo	
		Enew = kl*Ebond/ll2
C		Enew = 0.d0

		DE1 = Enew-Eold
		DE2 = 4.d0*eps1*(l2*Elj2-l1*Elj1)
		DEV = Pres*(Vnew - V0)-(nat+1)*DV/beta
		DElrc = Clrc*(1.0d0/Vnew-1.0d0/V0)
		DE = DE1 + DE2 + DEV + DElrc
c		write(10,*)Ebond, DE2, DEV
1000	  continue
 	
	  flag=.FALSE.
	  if(DE.lt.0.d0) then
	    flag=.TRUE.
	  else
	    w=dexp(-beta*DE)
	    rnd=ran(iseed)
	    if(rnd.lt.w) flag=.TRUE.
	  endif
c	  if (rchoice.eq.2) write(10,*)DV,DE,flag
	  if(mod(itest,Nfreq).eq.0) write(19,333) itest,E,Ebest,DEV

        if(flag) then
		kount = kount+1
c	    E = E+DE
		if(rchoice.eq.1) then
		   E = E+DE
		   xyz(1,ptrch,ptrat)=nc(1)
	       xyz(2,ptrch,ptrat)=nc(2)
	       xyz(3,ptrch,ptrat)=nc(3)
			if(natmc(ptrch).eq.1) goto 998
	       if(ptrat.ge.2) bnd(ptrch,ptrat-1)=b1
		   if(ptrat.le.natmax-1) bnd(ptrch,ptrat)=b2
			if(natmc(ptrch).le.2) goto 998
		   if ((ptrat.ge.2).and.(ptrat.le.natmax-1)) then
		      th(ptrch,ptrat-1) = theta0 ! #
		   endif
		   if (ptrat.ge.3) th(ptrch,ptrat-2) = theta1 ! #
		   if (ptrat.le.natmax-2) th(ptrch,ptrat) = theta2 ! #
	       if (ptrat.eq.1) th(ptrch,ptrat) = theta0
	       if (ptrat.eq.natmax) th(ptrch,ptrat-2) = theta0
			if(natmc(ptrch).le.3) goto 998
	       k = max(1,ptrat-1)
		   l = min(natmax,ptrat+2)
		   Do i=k,l
		      f(ptrch,i)=fnew(ptrch,i)
		   End Do
998			continue
			stepcount = stepcount+1
		else
		   E = E + DE1 + DE2 + DElrc
		   BL = BLnew
		   Blen = blen0/BL
		   Sig1 = sig10/BL
		   Sig12 = Sig1**2
		   rcutsq = rcut*rcut*sig12
		   ksi = ksi0/BL
		   kl=0.5d0*kl0*BL*BL
		   dens = dens*(V0/Vnew)
			boxcount=boxcount+1
			write(11,133) DV, DE1, DE2, DEV, DElrc
		endif
133	format(5(f12.5,2x))

c	Step Adjustment according to Acceptance Ratio
	
		if (mod(itest,atomcheck).eq.0) then
			ratio=real(stepcount)/real(nat*atomcheck)
			if (ratio.gt.0.5) then
				Ksi = Ksi*1.05
			else
				Ksi = Ksi*0.95
			endif
		endif
		if (mod(itest,boxcheck).eq.0) then
			ratio=real(boxcount)/real(boxcheck)
			if (ratio.gt.0.5) then
				Vstep = Vstep*1.05d0
			else
c				use dmax1 to avoid too small a step
				Vstep = dmax1(Vstep*0.95d0,0.1d0)
			endif
		endif

c	    if(itest.gt.Nstart.and.E.le.Ebest) then
	    if(E.le.Ebest) then
		  Ebest = E
c	      open(unit=13, file='mc.out',status='unknown')
c	      close(unit=13, status='delete')
c		  write(*,*) 'Round ', itest, ' mc.out file deleted'
c	      open(unit=13, file='mc.out',status='new')
	      open(unit=13, file=filout,status='unknown')
	      close(unit=13, status='delete')
	      open(unit=13, file=filout,status='new')
		  write(13,*) nch, nspec(0)
		  Do i=1,nspec(0)
			write(13,*) nspec(i), McNat(i), SuNat(i)
		  Enddo
		  write(13,*) BL,0.d0,0.d0
		  write(13,*) 0.d0,BL,0.d0
		  write(13,*) 0.d0,0.d0,BL
		  Do ich=1,nch
			  x = xyz(1,ich,1)
			  y = xyz(2,ich,1)
			  z = xyz(3,ich,1)
			  x = x - dnint(x)
			  y = y - dnint(y)
			  z = z - dnint(z)
			  if(Natmc(ich).eq.1) then
				  write(13,111) 1,x,y,z,f(ich,1)
				  goto 99
			  end if
			  write(13,111) 3,x,y,z,f(ich,1)
			  Do iat=2,Natmc(ich)-1
				  x = xyz(1,ich,iat)
				  y = xyz(2,ich,iat)
				  z = xyz(3,ich,iat)
				  x = x - dnint(x)
				  y = y - dnint(y)
				  z = z - dnint(z)
!				  write(13,110) ich,iat,x,y,z
				  write(13,111) 2,x,y,z,f(ich,iat)
			  End Do
			  x = xyz(1,ich,Natmc(ich))
			  y = xyz(2,ich,Natmc(ich))
			  z = xyz(3,ich,Natmc(ich))
			  x = x - dnint(x)
			  y = y - dnint(y)
			  z = z - dnint(z)
			  write(13,111) 3,x,y,z,f(ich,Natmc(ich))
99		  	  continue
		  End Do
		  write(13,*) 0
		  write(13,*) iabs(iseed)
		  write(13,*) dens
	    endif
	  endif
	  if(mod(itest,Nfreq).eq.0) write(10,*) BL, dens

	  if(mod(itest,10).eq.0) write(*,333) itest, Ebest,E,DE

c	write mc trajectory 

	  if(mod(itest,1000).eq.0) then 
		  write(97,*) BL,0.d0,0.d0
		  write(97,*) 0.d0,BL,0.d0
		  write(97,*) 0.d0,0.d0,BL
		  Do ich=1,nch
			  x = xyz(1,ich,1)
			  y = xyz(2,ich,1)
			  z = xyz(3,ich,1)
			  x = x - dnint(x)
			  y = y - dnint(y)
			  z = z - dnint(z)
			  if(Natmc(ich).eq.1) then
				  write(97,112) 1,x,y,z
				  goto 98
			  end if
			  write(97,112) 3,x,y,z
			  Do iat=2,Natmc(ich)-1
				  x = xyz(1,ich,iat)
				  y = xyz(2,ich,iat)
				  z = xyz(3,ich,iat)
				  x = x - dnint(x)
				  y = y - dnint(y)
				  z = z - dnint(z)
				  write(97,112) 2,x,y,z
			  End Do
			  x = xyz(1,ich,Natmc(ich))
			  y = xyz(2,ich,Natmc(ich))
			  z = xyz(3,ich,Natmc(ich))
			  x = x - dnint(x)
			  y = y - dnint(y)
			  z = z - dnint(z)
			  write(97,112) 3,x,y,z
98		  	  continue
		  End Do
	  endif
	End Do

c	write(13,*) 'Exited with last IERR = ', IERR
	write(13,*) 'Input file was :', filin
	write(13,*) 'This is file :', filout,' ,'
	write(13,*) 'generated within', Ntest,' steps'

	write(*,71) 
	write(13,71) 
	Do i=1,12
		write(*,72)	i,IERR(i)
		write(13,72)	i,IERR(i)
	End Do

	close(13)

333	format(i10,3(2x,f16.3))

110	format(i1,2x,i3,3(2x,f8.5))
111	format(i1,4(2x,f8.5))
112	format(i1,3(2x,f8.5))

71	format(/5x,'ERROR REPORT',5x/)
72	format(5x, 'IERR = ',i2,2x,i3,' times')
73	format('File with file name ',a12,' does not exist')
74	format('File with file name ',a12,' exists')
75	format('Specify another file name')


	end
